
#ifndef _DAMLDB_LOAD_RDF_COMMAND_HH
#define _DAMLDB_LOAD_RDF_COMMAND_HH

#if defined(sun)
#pragma ident "@(#)$Id: LoadRDFCommand.hh,v 1.1 2002/04/10 21:42:16 neves Exp $";
#endif

#include <damldb/IDamlDB.hh>
#include <rdfparse.h>

#ifdef CCXX_NAMESPACES
namespace damldb {
USING(std)
#endif

  class LoadRDFCommand
  {
  public:

    LoadRDFCommand();

    LoadRDFCommand(const string& path, const string& uri);

    LoadRDFCommand(IDamlDB& db);

    LoadRDFCommand(IDamlDB& db, const string& path, const string& uri);

    void load();

    IDamlDB& getDb() const;

    void setDb(IDamlDB& db);

    const string& getPath() const;

    void setPath(const string& path);

    const string& getURI() const;

    void setURI(const string& uri);

    size_t getStatmentCount() const;

    void setStatmentCount(size_t n);

    bool isVerbose() const;

    void setVerbose(bool verbose);

    void statement_handler(void *user_data,
			   RDF_SubjectType subject_type,
			   const XML_Char* subject,
			   const XML_Char* predicate,
			   int             ordinal,
			   RDF_ObjectType  object_type,
			   const XML_Char* object,
			   const XML_Char* xml_lang );

  private:

    void info(const string& p, const string& p2 = string("")) const;
    void warning(const string& p, const string& p2 = string("")) const;
    void error(const string& p, const string& p2 = string("")) const;

  private:

    IDamlDB* db_;
    bool verbose_;
    string path_;
    string uri_;
    size_t stmt_count_;
  };

#ifdef CCXX_NAMESPACES
} // namespace damldb
#endif

#ifndef DAMLDB_OUTLINE
#include "LoadRDFCommand.icc"
#endif

#endif /* !_DAMLDB_LOAD_RDF_COMMAND_HH */

// Emacs
// Local Variables:
// mode: c++
// c-basic-offset: 2
// End:

