
AC_DEFUN(OST_TRACE,[
	AC_MSG_CHECKING(for tracing)
	AC_ARG_ENABLE(trace, [  --enable-trace          compile for tracing])	
	if test -z "$enable_trace" ; then
		enable_trace="no"
	elif test $enable_trace = "yes" ; then
		CXXFLAGS="${CXXFLAGS} -DTRACE"
	fi
	AC_MSG_RESULT([$enable_trace])
])

AC_DEFUN(OST_LIB_DB,[
	AC_ARG_WITH(db-include,
		[  --with-db-include=DIR       define db include directory],
		[db_include="$withval"],[db_include=no]
	)
	AC_ARG_WITH(db-library,
		[  --with-db-library=DIR       define db lib directory],
		[db_library="$withval"],[db_library=no]
	)
	DB_LIBS=""
	DB_FLAGS=""
	ost_cv_db_libs=""

	if test "x$db_include" != "xno" -a "x$db_library" != "xno"; then
		DB_LIBS="-L$db_library -ldb"
		DB_FLAGS="-I$db_include"
		AC_DEFINE(HAVE_LIBDB)
		ost_cv_db_libs=libdb
	elif test "x$db_include" = "xno" -a "x$db_library" = "xno"; then
		AC_PATH_PROG(DB_CONFIG,db-config,no)
		dbver="0";
		if test "$DB_CONFIG" != "no"; then
			AC_MSG_CHECKING(for valid libdb)
			dbver=`$DB_CONFIG --version`
			dbver=`echo $dbver | \
				sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
			if test "$dbver" -ge 0	; then	
				AC_MSG_RESULT(yes)
				AC_DEFINE(HAVE_LIBDB)
				ost_cv_db_libs=libdb
				DB_LIBS=`$DB_CONFIG --libs`
				DB_FLAGS=`$DB_CONFIG --cflags`
			else
				AC_MSG_RESULT(no)
			fi
		fi
	else
		AC_MSG_ERROR([both --with-db-library=DIR and --with-db-include=DIR must be specified])
	fi
	
	AC_SUBST(DB_LIBS)
	AC_SUBST(DB_FLAGS)
])

AC_DEFUN(OST_LIB_EXPAT,[
	AC_ARG_WITH(expat-include,
		[  --with-expat-include=DIR       define expat include directory],
		[expat_include="$withval"],[expat_include=no]
	)
	AC_ARG_WITH(expat-library,
		[  --with-expat-library=DIR       define expat lib directory],
		[expat_library="$withval"],[expat_library=no]
	)
	EXPAT_LIBS=""
	EXPAT_FLAGS=""
	ost_cv_expat_libs=""

	if test "x$expat_include" != "xno" -a "x$expat_library" != "xno"; then
		EXPAT_LIBS="-L$expat_library -lexpat"
		EXPAT_FLAGS="-I$expat_include"
		AC_DEFINE(HAVE_LIBEXPAT)
		ost_cv_expat_libs=libexpat
	elif test "x$expat_include" = "xno" -a "x$expat_library" = "xno"; then
		AC_PATH_PROG(EXPAT_CONFIG,expat-config,no)
		expatver="0";
		if test "$EXPAT_CONFIG" != "no"; then
			AC_MSG_CHECKING(for valid libexpat)
			expatver=`$EXPAT_CONFIG --version`
			expatver=`echo $expatver | \
				sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
			if test "$expatver" -ge 0	; then	
				AC_MSG_RESULT(yes)
				AC_DEFINE(HAVE_LIBEXPAT)
				ost_cv_expat_libs=libexpat
				EXPAT_LIBS=`$EXPAT_CONFIG --libs`
				EXPAT_FLAGS=`$EXPAT_CONFIG --cflags`
			else
				AC_MSG_RESULT(no)
			fi
		fi
	else
		AC_MSG_ERROR([both --with-expat-library=DIR and --with-expat-include=DIR must be specified])
	fi
	
	AC_SUBST(EXPAT_LIBS)
	AC_SUBST(EXPAT_FLAGS)
])

AC_DEFUN(OST_LIB_LOG4CPP,[
	AC_PATH_PROG(LOG4CPP_CONFIG,log4cpp-config,no)
	LOG4CPP_LIBS=""
	LOG4CPP_FLAGS=""
	log4cppver="0";
	if test "$LOG4CPP_CONFIG" != "no" ; then
		AC_MSG_CHECKING(for valid liblog4cpp)
		log4cppver=`$LOG4CPP_CONFIG --version`
		log4cppver=`echo $log4cppver | \
			sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
		if test "$log4cppver" -ge 0	; then	
			AC_MSG_RESULT(yes)
			AC_DEFINE(HAVE_LIBLOG4CPP)
			ost_cv_log4cpp_libs=liblog4cpp
			LOG4CPP_LIBS=`$LOG4CPP_CONFIG --libs`
			LOG4CPP_FLAGS=`$LOG4CPP_CONFIG --cflags`
		else
			AC_MSG_RESULT(no)
		fi
	fi
	AC_SUBST(LOG4CPP_LIBS)
	AC_SUBST(LOG4CPP_FLAGS)
])

AC_DEFUN(OST_LIB_MYSQLCLIENT,[
	AC_ARG_WITH(mysql-include,
		[  --with-mysql-include=DIR       define mysql include directory],
		[mysql_include="$withval"],[mysql_include=no]
	)
	AC_ARG_WITH(mysql-library,
		[  --with-mysql-library=DIR       define mysql lib directory],
		[mysql_library="$withval"],[mysql_library=no]
	)
	MYSQL_LIBS=""
	MYSQL_FLAGS=""
	ost_cv_mysql_libs=""

	if test "x$mysql_include" != "xno" -a "x$mysql_library" != "xno"; then
		MYSQL_LIBS="-L$mysql_library -lmysqlclient"
		MYSQL_FLAGS="-I$mysql_include"
		AC_DEFINE(HAVE_LIBMYSQLCLIENT)
		ost_cv_mysql_libs=libmysqlclient
	elif test "x$mysql_include" = "xno" -a "x$mysql_library" = "xno"; then
		AC_PATH_PROG(MYSQL_CONFIG,mysql-config,no)
		mysqlver="0";
		if test "$MYSQL_CONFIG" != "no"; then
			AC_MSG_CHECKING(for valid libmysql)
			mysqlver=`$MYSQL_CONFIG --version`
			mysqlver=`echo $mysqlver | \
				sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
			if test "$mysqlver" -ge 0	; then	
				AC_MSG_RESULT(yes)
				AC_DEFINE(HAVE_LIBMYSQLCLIENT)
				ost_cv_mysql_libs=libmysql
				MYSQL_LIBS=`$MYSQL_CONFIG --libs`
				MYSQL_FLAGS=`$MYSQL_CONFIG --cflags`
			else
				AC_MSG_RESULT(no)
			fi
		fi
	else
		AC_MSG_ERROR([both --with-mysql-library=DIR and --with-msql-include=DIR must be specified])
	fi
	
	AC_SUBST(MYSQL_LIBS)
	AC_SUBST(MYSQL_FLAGS)
])

AC_DEFUN(OST_LIB_REPAT,[
	AC_ARG_WITH(repat-include,
		[  --with-repat-include=DIR       define repat include directory],
		[repat_include="$withval"],[repat_include=no]
	)
	AC_ARG_WITH(repat-library,
		[  --with-repat-library=DIR       define repat lib directory],
		[repat_library="$withval"],[repat_library=no]
	)
	REPAT_LIBS=""
	REPAT_FLAGS=""
	ost_cv_repat_libs=""

	if test "x$repat_include" != "xno" -a "x$repat_library" != "xno"; then
		REPAT_LIBS="-L$repat_library -lrepat"
		REPAT_FLAGS="-I$repat_include"
		AC_DEFINE(HAVE_LIBREPAT)
		ost_cv_repat_libs=librepat
	elif test "x$repat_include" = "xno" -a "x$repat_library" = "xno"; then
		AC_PATH_PROG(REPAT_CONFIG,repat-config,no)
		repatver="0";
		if test "$REPAT_CONFIG" != "no"; then
			AC_MSG_CHECKING(for valid librepat)
			repatver=`$REPAT_CONFIG --version`
			repatver=`echo $repatver | \
				sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
			if test "$repatver" -ge 0	; then	
				AC_MSG_RESULT(yes)
				AC_DEFINE(HAVE_LIBREPAT)
				ost_cv_repat_libs=librepat
				REPAT_LIBS=`$REPAT_CONFIG --libs`
				REPAT_FLAGS=`$REPAT_CONFIG --cflags`
			else
				AC_MSG_RESULT(no)
			fi
		fi
	else
		AC_MSG_ERROR([both --with-repat-library=DIR and --with-repat-include=DIR must be specified])
	fi
	
	AC_SUBST(REPAT_LIBS)
	AC_SUBST(REPAT_FLAGS)
])

AC_DEFUN(OST_LIB_DAMLDB,[
	AC_ARG_WITH(damldb-include,
		[  --with-damldb-include=DIR       define damldb include directory],
		[damldb_include="$withval"],[damldb_include=no]
	)
	AC_ARG_WITH(damldb-library,
		[  --with-damldb-library=DIR       define damldb lib directory],
		[damldb_library="$withval"],[damldb_library=no]
	)
	DAMLDB_LIBS=""
	DAMLDB_FLAGS=""
	ost_cv_damldb_libs=""

	if test "x$damldb_include" != "xno" -a "x$damldb_library" != "xno"; then
		DAMLDB_LIBS="-L$damldb_library -ldamldb"
		DAMLDB_FLAGS="-I$damldb_include"
		AC_DEFINE(HAVE_LIBDAMLDB)
		ost_cv_damldb_libs=libdamldb
	elif test "x$damldb_include" = "xno" -a "x$damldb_library" = "xno"; then
		AC_PATH_PROG(DAMLDB_CONFIG,damldb-config,no)
		damldbver="0";
		if test "$DAMLDB_CONFIG" != "no"; then
			AC_MSG_CHECKING(for valid libdamldb)
			damldbver=`$DAMLDB_CONFIG --version`
			damldbver=`echo $damldbver | \
				sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
			if test "$damldbver" -ge 0	; then	
				AC_MSG_RESULT(yes)
				AC_DEFINE(HAVE_LIBDAMLDB)
				ost_cv_damldb_libs=libdamldb
				DAMLDB_LIBS=`$DAMLDB_CONFIG --libs`
				DAMLDB_FLAGS=`$DAMLDB_CONFIG --cflags`
			else
				AC_MSG_RESULT(no)
			fi
		fi
	else
		AC_MSG_ERROR([both --with-damldb-library=DIR and --with-damldb-include=DIR must be specified])
	fi
	
	AC_SUBST(DAMLDB_LIBS)
	AC_SUBST(DAMLDB_FLAGS)
])

dnl ACCONFIG TEMPLATE
dnl #undef HAVE_LIBDB
dnl #undef HAVE_LIBEXPAT
dnl #undef HAVE_LIBLOG4CPP
dnl #undef HAVE_LIBMYSQLCLIENT
dnl #undef HAVE_LIBREPAT
dnl #undef HAVE_LIBDAMLDB
dnl END ACCONFIG
